de.caff.generics

## Interface LongIndexable

- All Superinterfaces:
    java.lang.Iterable<java.lang.Long>, PrimitiveLongIterable, Sizeable
  All Known Subinterfaces:
    ExpandableLongIndexable, MutableLongIndexable
  All Known Implementing Classes:
    LongIndexable.Base, LongPair, MutableLongIndexable.Base

      public interface LongIndexable
      extends PrimitiveLongIterable, Sizeable

  Class which allows readonly access of raw long integers by index.

  The `EMPTY` constant or `emptyIndexable()` method provide the same useful return value to indicate emptiness.

  Simple implementations should extend `LongIndexable.Base` because that provides useful implementations for standard Object methods and implements `Comparable`.

  Since:
    July 7, 2020
  Author:
    Rammi
  See Also:
    `FastLongSequenceSearch`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `LongIndexable.Base` Abstract base class which provides useful implementations for `Object.equals(Object)`, `Object.hashCode()`, `Object.toString()`.
    `static class` | `LongIndexable.LongIndexableSpliterator` Spliterator for long indexables.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static LongIndexable.Base` | `EMPTY` An empty indexable.

    - ### Fields inherited from interface de.caff.generics.PrimitiveLongIterable

      `EMPTY_LONG_ITERATOR`

    - ### Fields inherited from interface de.caff.generics.Sizeable

      `NULL`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default void` | `addAllTo(java.util.Collection<? super java.lang.Long> collection)` Add all elements of this indexable to the given collection.
    `default int` | `addToArray(long[] array, int pos)` Add the content of this indexable to the given array.
    `default int` | `addToArray(long[] array, int arrayPos, int index, int length)` Add a part of the content of this indexable to the given array.
    `default LongIndexable.Base` | `asBase()` Make this long integer indexable usable as a class with defined standard Object methods.
    `default java.util.Collection<java.lang.Long>` | `asCollection()` Get a view on this indexable as an unmodifiable collection.
    `default Indexable<java.lang.Long>` | `asIndexable()` Get a view of this indexable as a standard object-based indexable.
    `default java.util.List<java.lang.Long>` | `asList()` Get a view on this indexable as an unmodifiable list.
    `default int` | `binarySearch(long value)` Do a binary search in an indexable ordered in natural ascending order.
    `default int` | `binarySearch(long value, LongOrdering order)` Do a binary search in an ordered indexable.
    `static int` | `compare(LongIndexable indexable1, LongIndexable indexable2)` Compare two long indexables.
    `static int` | `compareUnsigned(LongIndexable indexable1, LongIndexable indexable2)` Compare two long indexables as if they contain unsigned long values.
    `static LongIndexable.Base` | `emptyIndexable()` Get an empty indexable set.
    `static boolean` | `equal(LongIndexable indexable1, LongIndexable indexable2)` Are two long indexables equal?
    `static boolean` | `equal(LongIndexable indexable1, java.lang.Object indexable2)` Are two long indexables equal?
    `default int` | `firstMatch(java.util.function.LongPredicate check)` Get the first index for which the given check is fulfilled.
    `default long` | `foldLeft(long initialValue, java.util.function.LongBinaryOperator foldOperation)` Go over all values and do a cumulative calculation.
    `default LongIndexable` | `frozen()` Get a frozen version of this indexable.
    `default java.util.Spliterator.OfLong` | `frozenLongSpliterator()` Get an immutable spliterator on a frozen copy of this indexable.
    `long` | `get(int index)` Get the element at the given index.
    `default long` | `getMod(int index)` Get an element modulo size.
    `default long` | `gyt(int index)` Pythonesque get.
    `static int` | `hash(LongIndexable indexable)` Calculate a hashcode for a long indexable.
    `default LongIndexable.Base` | `headSet(int toIndex)` Create an indexable subset from the last elements of this indexable set.
    `default java.lang.Iterable<java.lang.Integer>` | `indexes()` Get the indexes of this indexable as an iterable range.
    `static LongIndexable.Base` | `init(int size, long value)` Get a long indexable of a given size which always returns the same value.
    `static LongIndexable` | `initByIndex(int size, java.util.function.IntToLongFunction producer)` Get a long indexable of a given size which returns elements created by index.
    `default IntIndexable` | `intIndexes()` Get the indexes of this indexable as an integer indexable.
    `default boolean` | `isEmpty()` Is this indexable empty?
    `default boolean` | `isOrdered(LongOrdering order)` Is this indexable sorted according to the given ordering?
    `default boolean` | `isStrictlyOrdered(LongOrdering order)` Is this indexable strictly sorted according to the given ordering?
    `default java.util.Iterator<java.lang.Long>` | `iterator()` Returns an iterator over elements of type `T`.
    `default int` | `lastMatch(java.util.function.LongPredicate check)` Get the last index for which the given check is fulfilled.
    `default java.util.ListIterator<java.lang.Long>` | `listIterator()` Returns a list iterator over elements of type `T`.
    `default java.util.PrimitiveIterator.OfLong` | `longIterator()` Get an primitive long iterator.
    `default java.util.PrimitiveIterator.OfLong` | `longIterator(int from, int to)` Get a long iterator from the given sub set.
    `default java.util.Spliterator.OfLong` | `longSpliterator()` Get a spliterator on this indexable.
    `default int` | `nextMatch(int startIndex, java.util.function.LongPredicate check)` Get the next index for which the given check is fulfilled.
    `default MutableLongIndexable` | `ordered()` Create a (mutable) long indexable from the values of this indexable which is ordered in natural order.
    `default MutableLongIndexable` | `ordered(LongOrdering order)` Create a (mutable) long indexable from the values of this indexable which is ordered as defined by the given ordering.
    `default int` | `previousMatch(int startIndex, java.util.function.LongPredicate check)` Get the previous index for which the given check is fulfilled.
    `default LongIndexable.Base` | `reverse()` Get this indexable but with inverted order.
    `default LongIndexable` | `rotated(int steps)` Get a rotated view of this long indexable.
    `static LongIndexable.Base` | `singleton(long value)` View a single long value as a long indexable of size 1.
    `default LongIndexable.Base` | `subSet(int fromIndex, int toIndex)` Get an indexable subset.
    `default LongIndexable.Base` | `sybSet(int fromIndex, int toIndex)` Get an indexable subset.
    `default LongIndexable.Base` | `tailSet(int fromIndex)` Create an indexable subset from the last elements of this indexable set.
    `default long[]` | `toArray()` Convert this indexable into a Java array.
    `default java.util.ArrayList<java.lang.Long>` | `toList()` Create a list from this long indexable.
    `static java.lang.String` | `toString(LongIndexable indexable)` Create a string representation of the given indexable.
    `default <E> Indexable<E>` | `view(java.util.function.LongFunction<E> convert)` View this raw long indexable as if it has another element type.
    `static LongIndexable.Base` | `viewArray(long... array)` View an int array as an Indexable.
    `static LongIndexable.Base` | `viewArray(long[] array, int start, int length)` View part of an integer array as an Indexable.
    `static <T> LongIndexable.Base` | `viewArray(T[] array, java.util.function.ToLongFunction<? super T> valueExtract)` View an object array as a long indexable.
    `default BooleanIndexable` | `viewAsBoolean(java.util.function.LongPredicate convert)` View this indexable as a boolean indexable while using a conversion for each value.
    `default ByteIndexable` | `viewAsByte()` View this long indexable as a byte integer indexable.
    `default DoubleIndexable` | `viewAsDouble()` View this long indexable as a double indexable.
    `default DoubleIndexable` | `viewAsDouble(java.util.function.LongToDoubleFunction convert)` View this indexable as a double indexable while using a conversion for each value.
    `default FloatIndexable` | `viewAsFloat()` View this long indexable as a float indexable.
    `default IntIndexable` | `viewAsInt()` View this long indexable as a short integer indexable.
    `default IntIndexable` | `viewAsInt(java.util.function.LongToIntFunction convert)` View this indexable as an integer indexable while using a conversion for each value.
    `default ShortIndexable` | `viewAsShort()` View this long indexable as a short integer indexable.
    `static LongIndexable.Base` | `viewByIndex(int size, java.util.function.IntToLongFunction producer)` Get a long indexable of a given size which returns elements created by index.
    `static LongIndexable.Base` | `viewIndexable(Indexable<? extends java.lang.Number> indexable)` View a generic Number indexable as long indexable.
    `static LongIndexable.Base` | `viewIndexable(Indexable<? extends java.lang.Number> indexable, long nullFallback)` View a generic Number indexable as long indexable.
    `static <T> LongIndexable.Base` | `viewIndexable(Indexable<T> indexable, java.util.function.ToLongFunction<? super T> extractor)` View a generic indexable as a long indexable.
    `static LongIndexable.Base` | `viewList(java.util.List<? extends java.lang.Number> list)` View a list as an Indexable.
    `static LongIndexable.Base` | `viewList(java.util.List<? extends java.lang.Number> list, int nullValue)` View a list as an Indexable.
    `static <T> LongIndexable.Base` | `viewList(java.util.List<T> list, java.util.function.ToLongFunction<? super T> extractor)` View a generic list as a long indexable.
    `static LongIndexable.Base` | `viewNumberArray(java.lang.Number... array)` View a Number array as an Indexable.
    `default LongIndexable` | `viewOp(java.util.function.LongUnaryOperator op)` View this long indexable transformed by an operator.
    `default LongIndexable` | `withAppendedValue(long value)` Create a view with of this indexable with another value added at the end.
    `static LongIndexable.Base` | `withCachedHash(LongIndexable indexable)` Wrap an indexable with one which caches the hash value.
    `default LongIndexable` | `withExchangedValueAt(int index, long value)` Create a view of this long indexable with an exchanged value.
    `default LongIndexable` | `withInsertedValueAt(int index, long value)` Create a view of this long indexable with an inserted value.
    `default LongIndexable` | `withRemovedValueAt(int index)` Create a view of this indexable with one value removed.
    `default LongIndexable` | `withSwappedValuesAt(int index1, int index2)` Create a view of this long indexable with two values swapped.

    - ### Methods inherited from interface de.caff.generics.PrimitiveLongIterable

      `average, containsLong, forEachLong, forEachLongFragile, spliterator, stream, sum, sumX`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface de.caff.generics.Sizeable

      `size`

- - ### Field Detail

    - #### EMPTY

          @NotNull
          static final LongIndexable.Base EMPTY

      An empty indexable.

  - ### Method Detail

    - #### get

          long get(int index)

      Get the element at the given index.
      Parameters:
        `index` - index between `0` and `size() - 1`
      Returns:
        element at the given index

    - #### gyt

          default long gyt(int index)

      Pythonesque get. This allows accessing elements from the back by using negative indexes, e.g. `-1` references the last element, `-2` its predecessor, and so on.
      Parameters:
        `index` - index between `-size()` and `size() - 1`
      Returns:
        element at the given index

    - #### getMod

          default long getMod(int index)

      Get an element modulo size.

      This maps the given `index` into the range of this indexable by applying a modulo `Sizeable.size()` operation. For empty indexable this will throw an `IndexOutOfBoundsException` as there is no possible index to get.

      Parameters:
        `index` - index, possibly out of range, possibly even negative for Pythonesque access
      Returns:
        element at the given, possibly modulated, index

    - #### reverse

          @NotNull
          default LongIndexable.Base reverse()

      Get this indexable but with inverted order.
      Returns:
        a view to this indexable which accesses the elements in reverse order

    - #### isEmpty

          default boolean isEmpty()

      Is this indexable empty?
      Returns:
        `true`: there are no elements in this indexable
        `false`: this indexable has elements

    - #### longIterator

          @NotNull
          default java.util.PrimitiveIterator.OfLong longIterator()

      Get an primitive long iterator.
      Specified by:
        `longIterator` in interface `PrimitiveLongIterable`
      Returns:
        long iterator which iterates over this indexable

    - #### longIterator

          @NotNull
          default java.util.PrimitiveIterator.OfLong longIterator(int from,
                                                                           int to)

      Get a long iterator from the given sub set.
      Parameters:
        `from` - first index of iterator
        `to` - one past last index of iterator
      Returns:
        int iterator which iterates over the given part of this indexable

    - #### iterator

          @NotNull
          default java.util.Iterator<java.lang.Long> iterator()

      Returns an iterator over elements of type `T`.
      Specified by:
        `iterator` in interface `java.lang.Iterable<java.lang.Long>`
      Specified by:
        `iterator` in interface `PrimitiveLongIterable`
      Returns:
        an Iterator.

    - #### listIterator

          @NotNull
          default java.util.ListIterator<java.lang.Long> listIterator()

      Returns a list iterator over elements of type `T`.
      Returns:
        a list iterator.

    - #### subSet

          @NotNull
          default LongIndexable.Base subSet(int fromIndex,
                                                     int toIndex)

      Get an indexable subset. The subset includes indices `fromIndex` to `toIndex - 1`.
      Parameters:
        `fromIndex` - start index of sub set
        `toIndex` - index after last index
      Returns:
        indxable subset view of this indexable

    - #### sybSet

          @NotNull
          default LongIndexable.Base sybSet(int fromIndex,
                                                     int toIndex)

      Get an indexable subset. This is the Pythonesque version which allows negative indexes.
      Parameters:
        `fromIndex` - start index of sub set
        `toIndex` - end index of sub set
      Returns:
        indexable subset view of this indexable set

    - #### tailSet

          @NotNull
          default LongIndexable.Base tailSet(int fromIndex)

      Create an indexable subset from the last elements of this indexable set. This already allows Pythonesquew indexing.
      Parameters:
        `fromIndex` - index to start with, negative counts from the back
      Returns:
        indexable subset view of this indexable set

    - #### headSet

          default LongIndexable.Base headSet(int toIndex)

      Create an indexable subset from the last elements of this indexable set. This already allows Pythonesquew indexing.
      Parameters:
        `toIndex` - index one after the end (equal to the length of the returned set), negative counts from the back
      Returns:
        indexable subset view of this indexable set

    - #### asCollection

          @NotNull
          default java.util.Collection<java.lang.Long> asCollection()

      Get a view on this indexable as an unmodifiable collection. This is especially useful for conversion to standard collection classes, eg for adding all elements via `Collection.addAll(Collection)`.
      Returns:
        collection view

    - #### asList

          @NotNull
          default java.util.List<java.lang.Long> asList()

      Get a view on this indexable as an unmodifiable list. This is especially useful for conversion to standard collection classes, eg for adding all elements via `Collection.addAll(Collection)`.
      Returns:
        collection view
      See Also:
        `toList()`

    - #### toList

          @NotNull
          default java.util.ArrayList<java.lang.Long> toList()

      Create a list from this long indexable. This creates an independent list to which the elements of this indexable are copied.
      Returns:
        list copy of this indexable
      See Also:
        `asList()`

    - #### addAllTo

          default void addAllTo(@NotNull
                                java.util.Collection<? super java.lang.Long> collection)

      Add all elements of this indexable to the given collection.
      Parameters:
        `collection` - collection to add to

    - #### asIndexable

          @NotNull
          default Indexable<java.lang.Long> asIndexable()

      Get a view of this indexable as a standard object-based indexable.
      Returns:
        indexable with non-null `Long` values

    - #### toArray

          @NotNull
          default long[] toArray()

      Convert this indexable into a Java array.
      Returns:
        array copy containing all values of this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 long[] array,
                                 int pos)

      Add the content of this indexable to the given array.
      Parameters:
        `array` - array where the content is added
        `pos` - position in the array where the content of this indexable is added
      Returns:
        array position after this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 long[] array,
                                 int arrayPos,
                                 int index,
                                 int length)

      Add a part of the content of this indexable to the given array.
      Parameters:
        `array` - array where the content is added
        `arrayPos` - position in hte array where the content is added
        `index` - start index of this indexable which is added first
        `length` - number of entries of this indexable added to the array
      Returns:
        array position after the added content

    - #### indexes

          @NotNull
          default java.lang.Iterable<java.lang.Integer> indexes()

      Get the indexes of this indexable as an iterable range.
      Returns:
        iterable indexes
      See Also:
        `intIndexes()`, `Range.indexes(int)`

    - #### intIndexes

          @NotNull
          default IntIndexable intIndexes()

      Get the indexes of this indexable as an integer indexable.
      Returns:
        indexes as integer indexable
      See Also:
        `indexes()`, `IntIndexable.rangeFromSize(int)`

    - #### foldLeft

          default long foldLeft(long initialValue,
                                @NotNull
                                java.util.function.LongBinaryOperator foldOperation)

      Go over all values and do a cumulative calculation.

      Eg calculate the maximum of this indexable use

             long max = indexable.foldLeft(Long.MIN_VALUE, Math::max);

      Parameters:
        `initialValue` - start value for the operation, will be returned if this iterable is empty
        `foldOperation` - operation applied to each value, will get the accumulated value as its first and the current element value as its second argument
      Returns:
        accumulated value, result of applying fold operation to all values of this indexable iteratively

    - #### nextMatch

          default int nextMatch(int startIndex,
                                @NotNull
                                java.util.function.LongPredicate check)

      Get the next index for which the given check is fulfilled.
      Parameters:
        `startIndex` - start index for checking, `Pythonesque` indexing supported
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        next index starting with `startIndex` for which the check returns `true`, `Pythonesque.UNMAPPABLE` if none

    - #### firstMatch

          default int firstMatch(@NotNull
                                 java.util.function.LongPredicate check)

      Get the first index for which the given check is fulfilled.
      Parameters:
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        first index for which the check returns `true`, `-1` if none

    - #### previousMatch

          default int previousMatch(int startIndex,
                                    @NotNull
                                    java.util.function.LongPredicate check)

      Get the previous index for which the given check is fulfilled.
      Parameters:
        `startIndex` - start index for checking, `Pythonesque` indexing supported
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        next index starting with `startIndex` for which the check returns `true`, `Pythonesque.UNMAPPABLE` if none

    - #### lastMatch

          default int lastMatch(@NotNull
                                java.util.function.LongPredicate check)

      Get the last index for which the given check is fulfilled.
      Parameters:
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        last index for which the check returns `true`, `-1` if none

    - #### frozen

          @NotNull
          default LongIndexable frozen()

      Get a frozen version of this indexable.

      Often Indexables are used as a view to underlying collections. Although this interface is immutable, the underlying colelction might nevertheless change. This copies the current state of this indexable into an unmodifiable state, and returns an Indexable which is stable in size and will return always the same element for a given index. Beware: it is still possible that any element itself changes when the elements are mutable.

      Calling `frozen()` again on the returned object will just return the object itself, so you can safely call this method more than once.

      Returns:
        frozen version of this Indexable

    - #### longSpliterator

          @NotNull
          default java.util.Spliterator.OfLong longSpliterator()

      Get a spliterator on this indexable. The returned spliterator will not have its `Spliterator.IMMUTABLE` flag set, see `frozenLongSpliterator()` for an alternative.
      Returns:
        a spliterator on this indexable

    - #### frozenLongSpliterator

          @NotNull
          default java.util.Spliterator.OfLong frozenLongSpliterator()

      Get an immutable spliterator on a frozen copy of this indexable. If this indexable is already immutable (i.e. if `frozen()` returns `this`) then this is the same as `PrimitiveLongIterable.spliterator()` with the difference that the spliterator returned here will have its `Spliterator.IMMUTABLE` flag set. If this is not immutable a frozen copy will be created, and the spliterator will be operating on that. Please refer to `frozen()` to understand what level of immutabiliy it will provide.
      Returns:
        an "immutable" spliterator with the possible cost of copying this indexable

    - #### withInsertedValueAt

          @NotNull
          default LongIndexable withInsertedValueAt(int index,
                                                             long value)

      Create a view of this long indexable with an inserted value. Note that this is not efficient, but handy in certain situations where only 1 or a few values are inserted. Use `ExpandableLongIndexable` if you want to carry out more stuff like this.

      As this creates a view of this indexable, changes to this indexable might result in a disaster when using the returned indexable!

      Parameters:
        `index` - index where the value is inserted before the current index (not Pythonesque, because it is possible to add an value at `index == size()`, and it is expected that most insertion will happen at 0 or at the end)
        `value` - inserted value at that index
      Returns:
        a view of this indexable with 1 more value at the given index, all values beyond are moved one index forward
      See Also:
        `withAppendedValue(long)`

    - #### withAppendedValue

          @NotNull
          default LongIndexable withAppendedValue(long value)

      Create a view with of this indexable with another value added at the end. Note that this is not efficient, but handy in certain situations where only 1 or a few items are added.
      Parameters:
        `value` - value to add
      Returns:
        indexable view of this indexable, with the given value added at the end, so size is larger by 1
      See Also:
        `withInsertedValueAt(int, long)`

    - #### withExchangedValueAt

          @NotNull
          default LongIndexable withExchangedValueAt(int index,
                                                              long value)

      Create a view of this long indexable with an exchanged value. Note that this is not efficient, but handy in certain situations where only 1 or a few values are exchanged. Use `ExpandableLongIndexable` if you want to carry out more stuff like this.

      As this creates a view of this indexable, changes to this indexable could lead to unexpected results when using the returned indexable!

      Parameters:
        `index` - index where the element is exchanged, hiding the current element. (Pythonesque)
        `value` - exchanged value at that index
      Returns:
        a view of this indexable with 1 more element at the given index, all elements beyond are moved one index forward

    - #### withRemovedValueAt

          @NotNull
          default LongIndexable withRemovedValueAt(int index)

      Create a view of this indexable with one value removed. Note that this is not efficient, but handy in certain situations where only one or a few values are removed.
      Parameters:
        `index` - index of the removed value (Pythonesque)
      Returns:
        a view of this indexable where the value at the given index is removed

    - #### withSwappedValuesAt

          @NotNull
          default LongIndexable withSwappedValuesAt(int index1,
                                                             int index2)

      Create a view of this long indexable with two values swapped. Note that this is not efficient, but handy in certain situations where only a few items are swapped.
      Parameters:
        `index1` - index of the first value (Pythonesque)
        `index2` - index of the second value (Pythonesque)
      Returns:
        a view of this indexable where the first and second value have exchanged places

    - #### rotated

          @NotNull
          default LongIndexable rotated(int steps)

      Get a rotated view of this long indexable. The returned indexable will show this indexable with rotated indexes. A positive `steps` will rotate left, i.e. any index will be accessed as if the number of steps is added before extraction (modulo length). E.g. a rotation of `-1` will return the last element when index `0` is requested, and the first element for index `1`.
      Parameters:
        `steps` - steps to rotate
      Returns:
        rotated view of this indexable, use `frozen()` to create an indexable which no longer depends on this one

    - #### viewOp

          @NotNull
          default LongIndexable viewOp(@NotNull
                                                java.util.function.LongUnaryOperator op)

      View this long indexable transformed by an operator.
      Parameters:
        `op` - transforming operator
      Returns:
        view of this indexable with transformed values

    - #### viewAsDouble

          @NotNull
          default DoubleIndexable viewAsDouble()

      View this long indexable as a double indexable. Note that not all long values have an exact double representation. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a double indexable view of this indexable

    - #### viewAsDouble

          @NotNull
          default DoubleIndexable viewAsDouble(@NotNull
                                                        java.util.function.LongToDoubleFunction convert)

      View this indexable as a double indexable while using a conversion for each value.

      Use `frozen()` on the result to decouple it from this indexable.

      Parameters:
        `convert` - converter applied to each value of this indexable before it is returned from the resulting indexable
      Returns:
        double indexable view of this indexable

    - #### viewAsFloat

          @NotNull
          default FloatIndexable viewAsFloat()

      View this long indexable as a float indexable. Note that not all long values have an exact float representation. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a float indexable view of this indexable

    - #### viewAsInt

          @NotNull
          default IntIndexable viewAsInt()

      View this long indexable as a short integer indexable. Note that this may result in loss of numeric range of the values. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        an integer indexable view of this indexable

    - #### viewAsInt

          @NotNull
          default IntIndexable viewAsInt(@NotNull
                                                  java.util.function.LongToIntFunction convert)

      View this indexable as an integer indexable while using a conversion for each value.

      Use `frozen()` on the result to decouple it from this indexable.

      Parameters:
        `convert` - converter applied to each value of this indexable before it is returned from the resulting indexable
      Returns:
        integer indexable view of this indexable

    - #### viewAsShort

          @NotNull
          default ShortIndexable viewAsShort()

      View this long indexable as a short integer indexable. Note that this may result in severe loss of numeric range of the values. This will cast the values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a short integer indexable view of this indexable

    - #### viewAsByte

          @NotNull
          default ByteIndexable viewAsByte()

      View this long indexable as a byte integer indexable. Note that this may result in severe loss of numeric range of the values. This will cast the float values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a byte integer indexable view of this indexable

    - #### viewAsBoolean

          @NotNull
          default BooleanIndexable viewAsBoolean(@NotNull
                                                          java.util.function.LongPredicate convert)

      View this indexable as a boolean indexable while using a conversion for each value.

      Use `frozen()` on the result to decouple it from this indexable.

      Parameters:
        `convert` - converter applied to each value of this indexable before it is returned from the resulting indexable
      Returns:
        boolean indexable view of this indexable

    - #### viewList

          @NotNull
          static LongIndexable.Base viewList(@NotNull
                                                      java.util.List<? extends java.lang.Number> list)

      View a list as an Indexable. This requires a list of non-null numbers as a base.
      Parameters:
        `list` - list used as a base, required to have only non-null elements
      Returns:
        indexable view of the given list, so any changes of the list will be reflected by the returned Indexable

    - #### viewList

          @NotNull
          static LongIndexable.Base viewList(@NotNull
                                                      java.util.List<? extends java.lang.Number> list,
                                                      int nullValue)

      View a list as an Indexable. This allows to provide a fallback for null elements in the list.
      Parameters:
        `list` - list used as a base, required to have only non-null elements
        `nullValue` - value returned for `null` elements in the list
      Returns:
        indexable view of the given list, so any changes of the list will be reflected by the returned Indexable

    - #### viewList

          @NotNull
          static <T> LongIndexable.Base viewList(@NotNull
                                                          java.util.List<T> list,
                                                          @NotNull
                                                          java.util.function.ToLongFunction<? super T> extractor)

      View a generic list as a long indexable.
      Type Parameters:
        `T` - element type of list
      Parameters:
        `list` - generic list
        `extractor` - extractor function which extracts a long from the elements of `list`
      Returns:
        a long indexable view of `list`

    - #### viewIndexable

          @NotNull
          static LongIndexable.Base viewIndexable(@NotNull
                                                           Indexable<? extends java.lang.Number> indexable)

      View a generic Number indexable as long indexable.
      Parameters:
        `indexable` - generic indexable with Number elements, required to have only non-null elements
      Returns:
        long indexable view

    - #### viewIndexable

          @NotNull
          static LongIndexable.Base viewIndexable(@NotNull
                                                           Indexable<? extends java.lang.Number> indexable,
                                                           long nullFallback)

      View a generic Number indexable as long indexable.
      Parameters:
        `indexable` - generic indexable with Number elements
        `nullFallback` - fallback for `null` elements
      Returns:
        long indexable view

    - #### viewIndexable

          @NotNull
          static <T> LongIndexable.Base viewIndexable(@NotNull
                                                               Indexable<T> indexable,
                                                               @NotNull
                                                               java.util.function.ToLongFunction<? super T> extractor)

      View a generic indexable as a long indexable.
      Type Parameters:
        `T` - element type of indexable
      Parameters:
        `indexable` - generic indexable
        `extractor` - extractor function which extracts a long from the elements of `indexable`
      Returns:
        a long indexable view of `indexable`

    - #### viewNumberArray

          @NotNull
          static LongIndexable.Base viewNumberArray(@NotNull
                                                             java.lang.Number... array)

      View a Number array as an Indexable. To view only part of the array use `subSet(int, int)`.
      Parameters:
        `array` - array used as base, required to hold only non-null values
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static LongIndexable.Base viewArray(@NotNull
                                                       long... array)

      View an int array as an Indexable. To view only part of the array use `viewArray(long[], int, int)`.
      Parameters:
        `array` - array used as base
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static LongIndexable.Base viewArray(@NotNull
                                                       long[] array,
                                                       int start,
                                                       int length)

      View part of an integer array as an Indexable.
      Parameters:
        `array` - array used as base
        `start` - index of first byte to use from the array
        `length` - number of elements to use from the array
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static <T> LongIndexable.Base viewArray(@NotNull
                                                           T[] array,
                                                           @NotNull
                                                           java.util.function.ToLongFunction<? super T> valueExtract)

      View an object array as a long indexable.
      Type Parameters:
        `T` - array element type
      Parameters:
        `array` - viewed array
        `valueExtract` - converter from array elements to the long values of this indexable
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### singleton

          @NotNull
          static LongIndexable.Base singleton(long value)

      View a single long value as a long indexable of size 1.
      Parameters:
        `value` - single value
      Returns:
        indexable with one value

    - #### init

          @NotNull
          static LongIndexable.Base init(int size,
                                                  long value)

      Get a long indexable of a given size which always returns the same value.
      Parameters:
        `size` - size of the returned indexable
        `value` - value returned for each element
      Returns:
        indexable of size `size` with always the same element

    - #### viewByIndex

          @NotNull
          static LongIndexable.Base viewByIndex(int size,
                                                         @NotNull
                                                         java.util.function.IntToLongFunction producer)

      Get a long indexable of a given size which returns elements created by index. This will always call the `producer` when an element is requested. Use `frozen()` on the result to create an indexable which avoids this.
      Parameters:
        `size` - size of the returned indexable
        `producer` - producer which is called with an index and expected to return the associated value
      Returns:
        indexable view which calls the `producer` with the given index when an element is requested
      See Also:
        `initByIndex(int, IntToLongFunction)`

    - #### initByIndex

          @NotNull
          static LongIndexable initByIndex(int size,
                                                    @NotNull
                                                    java.util.function.IntToLongFunction producer)

      Get a long indexable of a given size which returns elements created by index. This will call the producer only once for each element during the call of this method, and return the results on later requests.
      Parameters:
        `size` - size of the returned indexable
        `producer` - producer which is called with an index and expected to return the associated value
      Returns:
        indexable with elements initialized by the `producer`
      See Also:
        `viewByIndex(int, IntToLongFunction)`

    - #### emptyIndexable

          @NotNull
          static LongIndexable.Base emptyIndexable()

      Get an empty indexable set.
      Returns:
        empty indexable

    - #### toString

          @NotNull
          static java.lang.String toString(@NotNull
                                                    LongIndexable indexable)

      Create a string representation of the given indexable.
      Parameters:
        `indexable` - indexable
      Returns:
        string representation

    - #### equal

          static boolean equal(@NotNull
                               LongIndexable indexable1,
                               @NotNull
                               LongIndexable indexable2)

      Are two long indexables equal?
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `true` if both indexables contain the same values in the same sequence
        `false` if sizes or values differ

    - #### equal

          static boolean equal(@NotNull
                               LongIndexable indexable1,
                               @Nullable
                               java.lang.Object indexable2)

      Are two long indexables equal? This is a convenience method which may be called from implementations for their `Object.equals(Object)` method.
      Parameters:
        `indexable1` - first indexable
        `indexable2` - object expected to be an indexable itself
      Returns:
        `true` if both indexables contain the same values in the same sequence
        `false` if the second object is not an indexable, of if sizes or values differ

    - #### compare

          static int compare(@NotNull
                             LongIndexable indexable1,
                             @NotNull
                             LongIndexable indexable2)

      Compare two long indexables. This compares the two indexable lexically element by element until either the first difference is found (smaller of the two values define the lower indexable) or the end of one is met (shorter indexable is less).
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `< 0>` if `indexable1 < indxable2`, `0` if `indexable1 == indexable2`, or `> 0` if `indexable1 > indexable2`

    - #### compareUnsigned

          static int compareUnsigned(@NotNull
                                     LongIndexable indexable1,
                                     @NotNull
                                     LongIndexable indexable2)

      Compare two long indexables as if they contain unsigned long values. This compares the two indexable lexically element by element until either the first difference is found (smaller of the two values define the lower indexable) or the end of one is met (shorter indexable is less).
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `< 0>` if `indexable1 < indxable2`, `0` if `indexable1 == indexable2`, or `> 0` if `indexable1 > indexable2`

    - #### hash

          static int hash(@NotNull
                          LongIndexable indexable)

      Calculate a hashcode for a long indexable.
      Parameters:
        `indexable` - indexable for which the hash code is required
      Returns:
        hash code for the given indexable

    - #### withCachedHash

          @NotNull
          static LongIndexable.Base withCachedHash(@NotNull
                                                            LongIndexable indexable)

      Wrap an indexable with one which caches the hash value. This is useful if indexables are used as hash keys because hash value calculation is expensive.

      The wrapped indexable must not change after it is wrapped, otherwise strange things are expected to happen.

      Parameters:
        `indexable` - wrapped indexable, must not change
      Returns:
        indexable which forwards most methods to `indexable`, but also provides useful implementations for `Object.hashCode()`, `Object.equals(Object)`, and `Object.toString()`

    - #### view

          default <E> Indexable<E> view(@NotNull
                                        java.util.function.LongFunction<E> convert)

      View this raw long indexable as if it has another element type.
      Type Parameters:
        `E` - element type of return view
      Parameters:
        `convert` - converter between long and the requested element type
      Returns:
        view of this raw long indexable

    - #### isOrdered

          default boolean isOrdered(@NotNull
                                    LongOrdering order)

      Is this indexable sorted according to the given ordering? This method tests that consecutive elements in this indexable or either ascending or the same, but never descending. See isStrictlyOrdered(LongOrdering) for a stricter alternative.
      Parameters:
        `order` - expected ordering
      Returns:
        `true` if this indexable is sorted as defined by `order`
        `false` if not

    - #### isStrictlyOrdered

          default boolean isStrictlyOrdered(@NotNull
                                            LongOrdering order)

      Is this indexable strictly sorted according to the given ordering? This method tests that consecutive elements in this indexable or strictly ascending or the same, but never descending. See isOrdered(LongOrdering) for a more relaxed alternative.
      Parameters:
        `order` - expected ordering
      Returns:
        `true` if this indexable is sorted as defined by `order`
        `false` if not

    - #### binarySearch

          default int binarySearch(long value)

      Do a binary search in an indexable ordered in natural ascending order. This requires this indexable to be ordered in `natural ascending order`, i.e. isOrdered(LongOrdering) has to return `true` for this ordering. For efficiency this prerequisite is not checked, but not fulfilling it will make this method return bogus results. If this indexable is only ordered, but not `strictly ordered` it is not defined which index is returned when the looked up value appears in a sequence of equal values.
      Parameters:
        `value` - value to look up
      Returns:
        a positive integer defining the index where the given value was found, and a negative integer if the value is not contained. The latter defines the insertion point where the looked up value would match into this sorted indexable in the form `-(insertIndex + 1)`.

    - #### binarySearch

          default int binarySearch(long value,
                                   @NotNull
                                   LongOrdering order)

      Do a binary search in an ordered indexable. This requires this indexable to be ordered in non-descending order as defined by the given `order`, i.e. isOrdered(LongOrdering) has to return `true` for this order. For efficiency this prerequisite is not checked, but not fulfilling it will make this method return bogus results. If this indexable is only ordered, but not `strictly ordered` it is not defined which index is returned when the looked up value appears in a sequence of equal values.
      Parameters:
        `value` - value to look up
        `order` - sort order
      Returns:
        a positive integer defining the index where the given value was found, and a negative integer if the value is not contained. The latter defines the insertion point where the looked up value would match into this sorted indexable in the form `-(insertIndex + 1)`.

    - #### ordered

          @NotNull
          default MutableLongIndexable ordered(@NotNull
                                                        LongOrdering order)

      Create a (mutable) long indexable from the values of this indexable which is ordered as defined by the given ordering.

      If natural ordering is required prefer calling `ordered()` because that typically runs 1.5 times faster.

      Parameters:
        `order` - sort order
      Returns:
        independent indexable with sorted values

    - #### ordered

          @NotNull
          default MutableLongIndexable ordered()

      Create a (mutable) long indexable from the values of this indexable which is ordered in natural order.

      This can be some 1.5x faster than using `ordered(LongOrdering)` with `natural order`.

      Returns:
        independent indexable with sorted values

    - #### asBase

          @NotNull
          default LongIndexable.Base asBase()

      Make this long integer indexable usable as a class with defined standard Object methods.
      Returns:
        based version of this indexable